//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4149994400D0.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4149994400D0.cm

//## begin module%4149994400D0.cp preserve=no
//## end module%4149994400D0.cp

//## Module: ResponseParam%4149994400D0; Package body
//## Subsystem: XSModel::Parameter%367691A8CEA0
//	/local/data/verisB/dorman/Xspec/src/XSModel/Parameter
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Parameter/ResponseParam.cxx

//## begin module%4149994400D0.additionalIncludes preserve=no
//## end module%4149994400D0.additionalIncludes

//## begin module%4149994400D0.includes preserve=yes
#include <XSContainer.h>
#include <XSstreams.h>
#include <XSModel/GlobalContainer/ModelContainer.h>
#include <XSModel/Parameter/ParameterLink.h>
#include <XSUtil/Error/Error.h>
#include <XSUtil/Parse/XSparse.h>
#include <XSUtil/Utils/XSstream.h>
#include <iomanip>
//## end module%4149994400D0.includes

// ResponseParam
#include <XSModel/Parameter/ResponseParam.h>
//## begin module%4149994400D0.declarations preserve=no
//## end module%4149994400D0.declarations

//## begin module%4149994400D0.additionalDeclarations preserve=yes
//## end module%4149994400D0.additionalDeclarations


// Class ResponseParam 

ResponseParam::ResponseParam (const string& initString, Response* responseParent, Response::ResponseParType parType)
  //## begin ResponseParam::ResponseParam%4149AEE0032C.hasinit preserve=yes
  : ModParam(initString),
    m_responseParent(responseParent),
    m_parType(parType),
    m_isPrompt(false)
  //## end ResponseParam::ResponseParam%4149AEE0032C.hasinit
  //## begin ResponseParam::ResponseParam%4149AEE0032C.initialization preserve=yes
  //## end ResponseParam::ResponseParam%4149AEE0032C.initialization
{
  //## begin ResponseParam::ResponseParam%4149AEE0032C.body preserve=yes
  //## end ResponseParam::ResponseParam%4149AEE0032C.body
}


ResponseParam::~ResponseParam()
{
  //## begin ResponseParam::~ResponseParam%414999A9025D_dest.body preserve=yes
  //## end ResponseParam::~ResponseParam%414999A9025D_dest.body
}



//## Other Operations (implementation)
ResponseParam* ResponseParam::clone (ComponentBase* p) const
{
  //## begin ResponseParam::clone%4149AF130317.body preserve=yes
  // p is just a dummy variable in this context.  ResponseParams
  // have no ComponentBase parent.
  p=0;
  ResponseParam* cloned = new ResponseParam(*this);
  cloned->parent(p);
  return cloned;
  //## end ResponseParam::clone%4149AF130317.body
}

void ResponseParam::freeze ()
{
  //## begin ResponseParam::freeze%4149B1610070.body preserve=yes
   ModParam::freeze();
  //## end ResponseParam::freeze%4149B1610070.body
}

void ResponseParam::changeValue (const string& parString)
{
  //## begin ResponseParam::changeValue%4151A8EC00CE.body preserve=yes
  bool isOk = false;
  string newParString = parString;
  // Don't let 'em out of here until either valid input has been
  // entered, or they've accepted the defaults.
  while (!isOk)
  {
     try
     {
        isOk = processValues(newParString);
     }
     catch (YellowAlert&)
     {
        // If ANY problems, have to try again.
     }
     if (!isOk)
     {
        rePrompt(newParString);
        if (newParString == XSparse::SKIP() || 
                        newParString == XSparse::USE_DEFAULT())
        {
           // They've accepted the defaults after all, 
           // make no changes to param values.
           isOk = true;
        }
     }
  }
  //## end ResponseParam::changeValue%4151A8EC00CE.body
}

bool ResponseParam::processValues (const string& parString)
{
  //## begin ResponseParam::processValues%4151C90D00F1.body preserve=yes
  
  // This is a bit different from the regular ModParam::processValues
  // because it's possible for a link expression to find its way down
  // here as a result of reprompting.  (ResponseParam's changeValue
  // reprompts until a valid string is entered.)
  bool isOK = false;
  if (parString.size() && parString[0] == '=')
  {
     thaw();
     link(parString.substr(1));
     // If the above didn't throw, assume everything is OK.
     isOK = true;
  }
  else
     isOK = ModParam::processValues(parString);
  return isOK;
  //## end ResponseParam::processValues%4151C90D00F1.body
}

void ResponseParam::rePrompt (string& newString) const
{
  //## begin ResponseParam::rePrompt%4151D43B02FB.body preserve=yes
  newString.erase();
  // Assumes only two parTypes for now...
  tcout <<  "\nInput parameter value, delta, min, bot, top, and max values for ..."
        << std::endl;
  try
  {
     tcout << parameterSetting() << std::endl;
     string promptString(m_responseParent->makeParamPromptString());
     promptString += name();
     promptString += ">";
     // This will throw if user enters "/*", but don't want to
     // print "terminated" message.
     XSstream::verbose(tperr, 999, 999);
     XSparse::basicPrompt(promptString, newString);
     XSstream::verbose(tperr);
     if (newString.empty())   newString = XSparse::USE_DEFAULT();
  }
  catch (YellowAlert&)
  {
     newString = XSparse::SKIP();
     XSstream::verbose(tperr);
  }
  
  //## end ResponseParam::rePrompt%4151D43B02FB.body
}

int ResponseParam::setValue (Real val, const char key)
{
  //## begin ResponseParam::setValue%41543DD00091.body preserve=yes
  int status = ModParam::setValue(val, key);
  if (!m_isPrompt && (key == 'a' || key == 'z' || key == 'v'))
  {
     m_responseParent->applyGainFromFit(m_parType);
  }
  return status;
  //## end ResponseParam::setValue%41543DD00091.body
}

void ResponseParam::setCompute (bool flag) const
{
  //## begin ResponseParam::setCompute%415D9C0E02D1.body preserve=yes
  // Find the model object (if any) that points to the response object 
  // that owns this parameter. 
  // (Can't assume models container even exists at this point, as
  //  this can get called through roundabout way (destruction of param
  //  links) during program shut-down.)
  if (XSContainer::models)
  {
     Model* affectedModel = XSContainer::models->lookup(m_responseParent);
     if (affectedModel)
     {
        affectedModel->setComputeFlag(flag);
     }
  }
  //## end ResponseParam::setCompute%415D9C0E02D1.body
}

void ResponseParam::reset () throw (Parameter::ResetFailure)
{
  //## begin ResponseParam::reset%49C7BC9100DA.body preserve=yes
  //## end ResponseParam::reset%49C7BC9100DA.body
}

void ResponseParam::reevaluateLink () const
{
  //## begin ResponseParam::reevaluateLink%49DA6088030B.body preserve=yes
   m_responseParent->applyGainFromFit(m_parType);
  //## end ResponseParam::reevaluateLink%49DA6088030B.body
}

std::ostream& ResponseParam::put (std::ostream& s) const
{
  //## begin ResponseParam::put%49F9C7880376.body preserve=yes
    using namespace std;
    ios_base::fmtflags saveFlags(s.flags());
    streamsize savePrec(s.precision());
    
    // Hardcode rmodel name to "gain" until general rmodel interface
    // is implemented.
    
    s << setw(4) << index()
      << setw(6) << m_responseParent->spectrumNumber() <<"    "
      << setw(9) << left << "gain"
      << setw(11) << left << name()
      << setw(7) << left << unit();
    
    s.precision(savePrec);
    s.flags(saveFlags);
    
    return ModParam::put(s);
  //## end ResponseParam::put%49F9C7880376.body
}

void ResponseParam::setValuesFromString (const string& paramStr)
{
  //## begin ResponseParam::setValuesFromString%4A006ADC035B.body preserve=yes
   string::size_type startPos = paramStr.find_first_not_of(" \t");
   string strippedParStr(paramStr.substr(startPos));
   if (strippedParStr.length())
   {
      try
      {
         m_isPrompt = true;
         modify(strippedParStr);
         m_isPrompt = false;
      }
      catch (...)
      {
         m_isPrompt = false;
         throw;
      }
   }
  //## end ResponseParam::setValuesFromString%4A006ADC035B.body
}

string ResponseParam::getParameterLabel () const
{
  //## begin ResponseParam::getParameterLabel%4A08647F036C.body preserve=yes
   std::ostringstream oss;
   oss << "resp " << m_responseParent->sourceNumber() << ":"
        << index();
   return oss.str();
  //## end ResponseParam::getParameterLabel%4A08647F036C.body
}

// Additional Declarations
  //## begin ResponseParam%414999A9025D.declarations preserve=yes
  //## end ResponseParam%414999A9025D.declarations

//## begin module%4149994400D0.epilog preserve=yes
//## end module%4149994400D0.epilog
